﻿using Infragistics.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGSlowLoading
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<XamDataGrid> grids = new List<XamDataGrid>();
        public MainWindow()
        {
            InitializeComponent();
            xdg.DataContext = Data.GetData(10, 1, 10);
            xdg2.DataContext = Data.GetData(10, 1, 10);
            xdg3.DataContext = Data.GetData(10, 1, 10);

            grids.Add(xdg);
            grids.Add(xdg2);
            grids.Add(xdg3);

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            XamDataGrid activeGrid = (xamTabControl1.SelectedContent as XamDataGrid);
            using (FileStream fs = new FileStream("xamDataGridLayout" + activeGrid.Name.ToString() + ".xml", FileMode.Open, FileAccess.Read))
            {
                activeGrid.LoadCustomizations(fs);
                fs.Close();
            }
        }

        private void xamTabControl1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.RemovedItems.Count != 0 && e.AddedItems.Count != 0)
            {
                XamDataGrid oldGrid = (e.RemovedItems[0] as TabItemEx).Content as XamDataGrid;
                XamDataGrid newGrid = (e.AddedItems[0] as TabItemEx).Content as XamDataGrid;

                if (newGrid != null && newGrid.Tag != null)
                {
                    newGrid.Loaded += (ss, ee) =>
                    {
                        using (FileStream fs = new FileStream("xamDataGridLayout" + newGrid.Name.ToString() + ".xml", FileMode.Open, FileAccess.Read))
                        {
                           newGrid.LoadCustomizations(fs);
                        }
                    };
                }
                using (FileStream fs = new FileStream("xamDataGridLayout" + oldGrid.Name.ToString() + ".xml", FileMode.Create, FileAccess.Write))
                {
                    oldGrid.SaveCustomizations(fs);
                    oldGrid.Tag = "available";
                }
            }
        }
    }
}
